// MP5SeriesDlg.h : header file
//

#if !defined(AFX_MP5SERIESDLG_H__212DCA99_40DD_4703_BDAD_0AB05BCA346F__INCLUDED_)
#define AFX_MP5SERIESDLG_H__212DCA99_40DD_4703_BDAD_0AB05BCA346F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "AutonicsComCtrl.h"
#include "FNDDisplay.h"
#include "LEDDisplay.h"



/////////////////////////////////////////////////////////////////////////////
// CMP5SeriesDlg dialog
#define MP5_MAX_NUM		100
typedef struct {	// 26bytes
	short	addr;
	float	value;
	float	hh;
	float	h;
	float	l;
	float	ll;
	float	peak_max;
	float	peak_min;
	float	prescale_x_a;
	float	prescale_x_b;
	float	prescale_y_a;
	float	prescale_y_b;
} stValue;

class CMP5SeriesDlg : public CDialog
{
// Construction
public:
	CMP5SeriesDlg(CWnd* pParent = NULL);	// standard constructor

	CAutonicsComCtrl	m_comm;
	CFNDDisplay			m_FND;
	CLEDDisplay			m_LED;
	char				m_FND_Value[30];

	char				m_Addr[MP5_MAX_NUM];
	char				m_AddrCurrIndex;
	char				m_AddrRequest;
	char				m_Request;
	char				m_MainRequest;
	char				m_MaxNum;
	CString				m_Unit;

	void Init();
	void Close();
	void PNPList(int addr, int stat);
	int ReadPacket(stValue* parameter=NULL);
	int SendPacket(int addr, int command, int bank, int code, double value);
	int ParameterLoad(void* parameter, CProgressCtrl* pProgress=NULL);

	// Comm-config
	int					m_Comm_Port;
	int					m_Comm_Baudrate;
	int					m_Comm_DataBit;
	int					m_Comm_ParityBit;
	int					m_Comm_StopBit;

	void Pause();
	void Restart();

	
// Dialog Data
	//{{AFX_DATA(CMP5SeriesDlg)
	enum { IDD = IDD_MP5SERIES_DIALOG };
	CProgressCtrl	m_Progress;
	CStatic	m_ETXCRC;
	CStatic	m_Frame;
	CEdit	m_ReceiveMsg;
	CEdit	m_SendMsg;
	CComboBox	m_AddrList;
	CButton	m_Bank;
	CButton	m_PNP;
	CButton	m_Auto;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMP5SeriesDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMP5SeriesDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonSend();
	afx_msg void OnStaticFront();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCheckAuto();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MP5SERIESDLG_H__212DCA99_40DD_4703_BDAD_0AB05BCA346F__INCLUDED_)
