Attribute VB_Name = "Module_CRC"
Option Explicit
Dim CRC8_table(0 To 255) As Byte

Public Sub CRC8_init()
    Dim TempTable As Variant
    Dim i As Integer

    TempTable = Array( _
        &H0, &H5E, &HBC, &HE2, &H61, &H3F, &HDD, &H83, &HC2, &H9C, &H7E, &H20, &HA3, &HFD, &H1F, &H41, _
        &H9D, &HC3, &H21, &H7F, &HFC, &HA2, &H40, &H1E, &H5F, &H1, &HE3, &HBD, &H3E, &H60, &H82, &HDC, _
        &H23, &H7D, &H9F, &HC1, &H42, &H1C, &HFE, &HA0, &HE1, &HBF, &H5D, &H3, &H80, &HDE, &H3C, &H62, _
        &HBE, &HE0, &H2, &H5C, &HDF, &H81, &H63, &H3D, &H7C, &H22, &HC0, &H9E, &H1D, &H43, &HA1, &HFF, _
        &H46, &H18, &HFA, &HA4, &H27, &H79, &H9B, &HC5, &H84, &HDA, &H38, &H66, &HE5, &HBB, &H59, &H7, _
        &HDB, &H85, &H67, &H39, &HBA, &HE4, &H6, &H58, &H19, &H47, &HA5, &HFB, &H78, &H26, &HC4, &H9A, _
        &H65, &H3B, &HD9, &H87, &H4, &H5A, &HB8, &HE6, &HA7, &HF9, &H1B, &H45, &HC6, &H98, &H7A, &H24, _
        &HF8, &HA6, &H44, &H1A, &H99, &HC7, &H25, &H7B, &H3A, &H64, &H86, &HD8, &H5B, &H5, &HE7, &HB9, _
        &H8C, &HD2, &H30, &H6E, &HED, &HB3, &H51, &HF, &H4E, &H10, &HF2, &HAC, &H2F, &H71, &H93, &HCD, _
        &H11, &H4F, &HAD, &HF3, &H70, &H2E, &HCC, &H92, &HD3, &H8D, &H6F, &H31, &HB2, &HEC, &HE, &H50, _
        &HAF, &HF1, &H13, &H4D, &HCE, &H90, &H72, &H2C, &H6D, &H33, &HD1, &H8F, &HC, &H52, &HB0, &HEE, _
        &H32, &H6C, &H8E, &HD0, &H53, &HD, &HEF, &HB1, &HF0, &HAE, &H4C, &H12, &H91, &HCF, &H2D, &H73, _
        &HCA, &H94, &H76, &H28, &HAB, &HF5, &H17, &H49, &H8, &H56, &HB4, &HEA, &H69, &H37, &HD5, &H8B, _
        &H57, &H9, &HEB, &HB5, &H36, &H68, &H8A, &HD4, &H95, &HCB, &H29, &H77, &HF4, &HAA, &H48, &H16, _
        &HE9, &HB7, &H55, &HB, &H88, &HD6, &H34, &H6A, &H2B, &H75, &H97, &HC9, &H4A, &H14, &HF6, &HA8, _
        &H74, &H2A, &HC8, &H96, &H15, &H4B, &HA9, &HF7, &HB6, &HE8, &HA, &H54, &HD7, &H89, &H6B, &H35)

    For i = 0 To UBound(TempTable)
       CRC8_table(i) = TempTable(i)
    Next i
End Sub

Function CRC8table_packet(ByRef Packet As String, ByRef Size As Integer) As Byte
    Dim CRC As Byte
    Dim i As Integer

    CRC = 0

    For i = 1 To Size
        CRC = CRC8_table(CRC Xor Asc(Mid(Packet, i, 1)))
    Next i

    CRC8table_packet = CRC
End Function

Function BCC_packet(ByRef Packet As String, ByRef Size As Integer) As Byte
    Dim BCC As Byte
    Dim i As Integer

    BCC = 0

    For i = 1 To Size
        BCC = BCC Xor Asc(Mid(Packet, i, 1))
    Next i

    BCC_packet = BCC
End Function


Public Sub WaitTimer(ByRef Time As Single)
    Dim hTimer As Single
    hTimer = Timer + (Time / 100)
    Do
        DoEvents
    Loop Until hTimer < Timer
End Sub
